package prupp;

// $Id: LogView.java,v 1.1.1.1 1998/08/10 21:13:36 d94-rol Exp $

import java.awt.*;
import java.awt.event.*;
import java.util.*;

/** a window to display whats happening to the proxy
 */
public class LogView extends Frame implements Runnable, Logger.LogViewer
{
    private Logger log;
    private TextArea ta;
    private Thread runner;
    private boolean loggerChanged = true;

    /** Create a logview for the specified log.
     * @param log the log were watching.
     */
    public LogView (Logger log) 
	{
	    super ("RabbIT - vad gr den nu!");
	    this.log = log;
	    addWindowListener (new WindowAdapter (){
		public void windowClosing(WindowEvent e) {
		    setVisible (false);
		    runner.stop ();
		    dispose ();					   
		}
	    });
	    ta = new TextArea (30,30);
	    //ta.setEnabled (false);
	    add (ta);
	    validate ();
	    pack ();
	    setVisible (true);
	    runner = new Thread (this);
	    runner.start ();
	    log.addViewer (this);
	}

    /** flag that the log has changed
     */
    public void setChanged () {
	loggerChanged = true;
    }
    

    /** eternal loop, if log has changed redisplay
     */
    public void run () {	
	while (true) {
	    Enumeration e = log.keys ();

	    if (loggerChanged) {
		loggerChanged = false;
		    
		ta.setText ("");
		int val;
		    
		while (e.hasMoreElements ()) {
		    String type = (String) e.nextElement ();
		    val = log.get (type);
		    ta.append (type + ": " + val + "\n");
		}
	    }
		

	    try {
		Thread.sleep (500);
	    } catch (InterruptedException err) {
		System.err.println ("det blev en FL!\n"+ err);
	    }
	}
    }
}
