package prupp;

// $Id: NCacheEntry.java,v 1.1 1999/01/17 22:12:25 d94-rol Exp $

import java.io.*;
import java.util.Date;


/** 
 *  A cached object.
 */
public class NCacheEntry implements Serializable
{
    private Object key = null;
    private Date expires = null;
    private String filename = null;
    private long size = 0;
    private long id = 0;

    /** Create a new CacheEntry for given key and filename
     * @param key the key for the object.
     * @param filename the filename were we store our data
     */
    public NCacheEntry (Object key, String filename, long id) {
	this.key = key;
	this.filename = filename;
	this.id = id;
    }    
    
    /** get the filename were data is stored
     * @return a filename
     */
    public String getFileName () {
	return filename;
    }
    
    /** set the filename were we will save data
     * @param filename the name of the File were data is saved.
     */
    protected void setFileName (String filename) {
	this.filename = filename;
    }
    
    /** Set the key were holding data for
     * @param key the key we have data for
     */
    protected void setKey (Object key) {
	this.key = key;
    }
    
    /** get the key were holding data for
     * @return the keyobject
     */
    public Object getKey () {
	return key;
    }   
    
    /** get the size of our file
     * @return the size of our data
     */
    public long getSize () {
	return size;
    }  
    /** sets the size of our data
     * @param size the new Size
     */
    public void setSize (long size) {
	this.size = size;
    }

    /** get the expiry-date of our file
     * @return the expiry date of our data
     */
    public Date getExpires () {
	return expires;
    }  
    /** sets the expirydate of our data
     * @param d the new expiry-date.
     */
    public void setExpires (Date d) {
	this.expires = d;
    }
    
    /** get the id of our entry.
     * @return the id of the entry.
     */
    public long getId () {
	return id;
    }
}
